/*
 * MainFrame.java
 *
 * Created on October 16, 2001, 6:44 PM
 */

package fina2;

import java.util.Iterator;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import fina2.i18n.Language;
import fina2.security.User;

/**
 * 
 * @author David Shalamberidze
 */
public class MainFrame extends javax.swing.JFrame {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private Vector minimized = new Vector();

	/** Creates new form MainFrame */
	public MainFrame() {
		setIconImage(ui.getIcon("fina2.icon").getImage());
		initComponents();
		setJMenuBar(ui.getMenuBar());
		// pack();
		java.awt.Dimension screen = java.awt.Toolkit.getDefaultToolkit()
				.getScreenSize();
		java.awt.Dimension d = getSize();
		// setSize(screen.width, d.height);
		// setLocation(0,0);

		setExtendedState(MAXIMIZED_BOTH);
		try {
			User user = (User) main.getUserHandle().getEJBObject();
			Language lang = (Language) main.getLanguageHandle().getEJBObject();
			loginText.setText(user.getLogin());
			userText.setText(user.getName(main.getLanguageHandle()));
			languageText.setText(lang.getDescription());
			serverTextField.setText(main.getServerHost());
		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
		BaseFrame.ensureVisible(this);
	}

	public javax.swing.JDesktopPane getDesktop() {
		return desktop;
	}

	public void setStatusText(String status) {
		jLabel2.setText(status);
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jLabel2 = new javax.swing.JLabel();
		jPanel2 = new javax.swing.JPanel();
		jPanel1 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		loginText = new javax.swing.JTextField();
		jLabel3 = new javax.swing.JLabel();
		userText = new javax.swing.JTextField();
		jLabel4 = new javax.swing.JLabel();
		languageText = new javax.swing.JTextField();
		jScrollPane1 = new javax.swing.JScrollPane();
		desktop = new javax.swing.JDesktopPane();
		serverLabel = new JLabel();
		serverTextField = new JTextField();

		setTitle(ui.getString("fina2.title"));
		addComponentListener(new java.awt.event.ComponentAdapter() {
			public void componentResized(java.awt.event.ComponentEvent evt) {
				formComponentResized(evt);
			}

			public void componentMoved(java.awt.event.ComponentEvent evt) {
				formComponentMoved(evt);
			}
		});

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				formWindowClosing(evt);
			}

			public void windowClosed(java.awt.event.WindowEvent evt) {
				formWindowClosed(evt);
			}

			public void windowIconified(java.awt.event.WindowEvent evt) {
				formWindowIconified(evt);
			}

			public void windowDeiconified(java.awt.event.WindowEvent evt) {
				formWindowDeiconified(evt);
			}
		});

		jLabel2.setText(" Ready");
		jLabel2.setFont(ui.getFont());
		jLabel2.setBorder(new javax.swing.border.EtchedBorder());
		getContentPane().add(jLabel2, java.awt.BorderLayout.SOUTH);

		jPanel2.setLayout(new java.awt.BorderLayout());

		jLabel1.setText(ui.getString("fina2.userLoginNameLabel"));
		jLabel1.setFont(ui.getFont());
		jPanel1.add(jLabel1);

		loginText.setEditable(false);
		loginText.setColumns(8);
		loginText.setFont(ui.getFont());
		jPanel1.add(loginText);

		jLabel3.setText(ui.getString("fina2.userNameLabel"));
		jLabel3.setFont(ui.getFont());
		jPanel1.add(jLabel3);

		userText.setEditable(false);
		userText.setColumns(20);
		userText.setFont(ui.getFont());
		jPanel1.add(userText);

		jLabel4.setText(ui.getString("fina2.languageLabel"));
		jLabel4.setFont(ui.getFont());
		jPanel1.add(jLabel4);

		languageText.setEditable(false);
		languageText.setColumns(10);
		languageText.setFont(ui.getFont());
		jPanel1.add(languageText);

		serverLabel.setText(ui.getString("fina2.serverAddress"));
		serverLabel.setFont(ui.getFont());
		jPanel1.add(serverLabel);

		serverTextField.setEditable(false);
		serverTextField.setColumns(10);
		serverTextField.setFont(ui.getFont());
		jPanel1.add(serverTextField);

		jPanel2.add(jPanel1, java.awt.BorderLayout.WEST);

		getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

		jScrollPane1.setViewportView(desktop);

		getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

	}// GEN-END:initComponents

	private void formWindowClosing(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_formWindowClosing
		ui.getAction("fina2.actions.exit").actionPerformed(null);
	}// GEN-LAST:event_formWindowClosing

	private void formComponentResized(java.awt.event.ComponentEvent evt) {// GEN-FIRST:event_formComponentResized
		ui.putConfigValue("fina2.MainFrame.width", new Integer(getWidth()));
		ui.putConfigValue("fina2.MainFrame.height", new Integer(getHeight()));
	}// GEN-LAST:event_formComponentResized

	private void formComponentMoved(java.awt.event.ComponentEvent evt) {// GEN-FIRST:event_formComponentMoved
		ui.putConfigValue("fina2.MainFrame.x", new Integer(getX()));
		ui.putConfigValue("fina2.MainFrame.y", new Integer(getY()));
	}// GEN-LAST:event_formComponentMoved

	private void formWindowClosed(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_formWindowClosed
		ui.getAction("fina2.actions.exit").actionPerformed(null);
	}// GEN-LAST:event_formWindowClosed

	private void formWindowDeiconified(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_formWindowDeiconified
		for (Iterator iter = minimized.iterator(); iter.hasNext();) {
			JFrame f = (JFrame) iter.next();
			f.show();
		}
	}// GEN-LAST:event_formWindowDeiconified

	private void formWindowIconified(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_formWindowIconified
		minimized.removeAllElements();
		java.awt.Frame[] frames = getFrames();
		for (int i = 0; i < frames.length; i++) {
			if (frames[i].isVisible() && !frames[i].equals(this)) {
				frames[i].hide();
				minimized.add(frames[i]);
			}
		}
	}// GEN-LAST:event_formWindowIconified

	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_exitForm
		ui.getAction("fina2.actions.exit").actionPerformed(null);
	}// GEN-LAST:event_exitForm

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JTextField languageText;
	private javax.swing.JTextField userText;
	private javax.swing.JDesktopPane desktop;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JTextField loginText;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JLabel serverLabel;
	private javax.swing.JTextField serverTextField;
	// End of variables declaration//GEN-END:variables

}
