/*
 * BankRegionSelectDialod.java
 *
 * Created on March 26, 2002, 5:16 AM
 */

package fina2.bank;

import java.awt.GridBagConstraints;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.ListSelectionModel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import fina2.Main;
import fina2.ui.UIManager;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;
import fina2.ui.table.TableRowImpl;

/**
 * 
 * @author vasop
 */
@Deprecated
public class BankRegionSelectDialod extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private EJBTable table;
	private TableRow tableRow;

	/** Creates new form BankRegionSelectDialod */
	public BankRegionSelectDialod(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		table = new EJBTable();
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table.addSelectionListener(new javax.swing.event.ListSelectionListener() {
			public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
				if (table.getSelectedRow() == -1) {
					okButton.setEnabled(false);
				} else {
					okButton.setEnabled(true);
				}
			}
		});

		table.addMouseListener(new java.awt.event.MouseListener() {
			public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
			}

			public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
			}

			public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
			}

			public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
				if (mouseEvent.getClickCount() == 2) {
					if (table.getSelectedRow() != -1) {
						okButtonActionPerformed(null);
					}
				}
			}

			public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
			}
		});
		initComponents();
		scrollPane.setViewportView(table);
		setLocationRelativeTo(parent);
	}

	public TableRow getTableRow() {
		return tableRow;
	}

	@SuppressWarnings("unchecked")
	private void initTable() {
		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/bank/BankRegionSession");
			BankRegionSessionHome home = (BankRegionSessionHome) PortableRemoteObject.narrow(ref, BankRegionSessionHome.class);

			BankRegionSession session = home.create();

			Vector colNames = new Vector();
			colNames.add(ui.getString("fina2.bank.city"));
			colNames.add(ui.getString("fina2.bank.region"));

			Collection rows = session.getRegionRows(main.getUserHandle(), main.getLanguageHandle());

			if (cityText.getText().length() != 0 || regionText.getText().length() != 0) {
				Iterator iter = rows.iterator();
				while (iter.hasNext()) {
					TableRowImpl obj = (TableRowImpl) iter.next();
					if (!obj.getValue(0).toLowerCase().contains(cityText.getText().trim().toLowerCase()) || !obj.getValue(1).toLowerCase().contains(regionText.getText().trim().toLowerCase())) {
						iter.remove();
					}
				}
			}
			table.initTable(colNames, rows);

		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
	}

	public void show() {
		if (isVisible())
			return;

		initTable();

		super.show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jFilter = new javax.swing.JPanel();
		jPanel1 = new javax.swing.JPanel();
		scrollPane = new javax.swing.JScrollPane();
		jPanel2 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();

		setTitle(ui.getString("fina2.bank.regionSelectDialod"));
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});
		jFilter.setLayout(new java.awt.GridBagLayout());
		cityText = new javax.swing.JTextField();
		cityText.setColumns(20);
		cityText.setFont(ui.getFont());
		jFilter.add(cityText, UIManager.getGridBagConstraints(-1, -1, -1, -1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(0, 0, 0, 5)));

		regionText = new javax.swing.JTextField();
		regionText.setColumns(20);
		regionText.setFont(ui.getFont());
		jFilter.add(regionText, UIManager.getGridBagConstraints(-1, -1, -1, -1, -1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(0, 0, 0, 5)));

		jPanel1.setLayout(new java.awt.BorderLayout());

		getContentPane().add(jFilter, java.awt.BorderLayout.NORTH);

		scrollPane.setPreferredSize(new java.awt.Dimension(350, 350));
		jPanel1.add(scrollPane, java.awt.BorderLayout.CENTER);

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		DocumentListener documentListener = new DocumentListener() {
			public void changedUpdate(DocumentEvent documentEvent) {
				// ignore
			}

			public void insertUpdate(DocumentEvent documentEvent) {
				initTable();
			}

			public void removeUpdate(DocumentEvent documentEvent) {
				initTable();
			}

		};
		cityText.getDocument().addDocumentListener(documentListener);
		regionText.getDocument().addDocumentListener(documentListener);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel2.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel2.add(cancelButton);

		getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

		getContentPane().addComponentListener(new java.awt.event.ComponentAdapter() {
			public void componentResized(java.awt.event.ComponentEvent e) {
				regionText.setColumns((int) (e.getComponent().getWidth() / 18.1));
				cityText.setColumns((int) (e.getComponent().getWidth() / 18.1));
			}

		});
		pack();
	}// GEN-END:initComponents

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelButtonActionPerformed
		setVisible(false);
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_okButtonActionPerformed
		tableRow = table.getSelectedTableRow();
		setVisible(false);
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jFilter;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JScrollPane scrollPane;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JButton okButton;
	private javax.swing.JButton cancelButton;
	private javax.swing.JTextField cityText;
	private javax.swing.JTextField regionText;
	// End of variables declaration//GEN-END:variables

}
