/*
 * ManagingBodyAmendDialog.java
 *
 * Created on 1  2002 ., 12:39
 */

package fina2.bank;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.transaction.UserTransaction;

import fina2.Main;
import fina2.ui.UIManager;
import fina2.ui.table.TableRow;
import fina2.ui.table.TableRowImpl;

/**
 * 
 * @author Vasop
 */
public class ManagingBodyAmendDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private TableRow tableRow;
	private ManagingBody managingBody;
	private boolean canAmend;

	/** Creates new form ManagingBodyAmendDialog */
	public ManagingBodyAmendDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		initComponents();

	}

	public TableRow getTableRow() {
		return tableRow;
	}

	public void show(TableRow tableRow, boolean canAmend) {
		this.tableRow = tableRow;
		this.canAmend = canAmend;
		managingBodyText.setEditable(canAmend);
		managingBody = null;
		if (tableRow != null) {

			ManagingBodyPK pk = (ManagingBodyPK) tableRow.getPrimaryKey();

			try {
				InitialContext jndi = fina2.Main.getJndiContext();
				Object ref = jndi.lookup("fina2/bank/ManagingBody");
				ManagingBodyHome home = (ManagingBodyHome) PortableRemoteObject.narrow(ref, ManagingBodyHome.class);

				managingBody = home.findByPrimaryKey(pk);

				managingBodyText.setText(managingBody.getManagingBody(main.getLanguageHandle()));

			} catch (Exception e) {
				Main.generalErrorHandler(e);
				return;
			}
		} else {
			managingBodyText.setText("");
		}
		setLocationRelativeTo(getParent());
		show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel1 = new javax.swing.JPanel();
		managingBodyLabel = new javax.swing.JLabel();
		managingBodyText = new javax.swing.JTextField();
		jPanel2 = new javax.swing.JPanel();
		jPanel3 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel1.setLayout(new java.awt.GridBagLayout());

		jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(30, 70, 30, 70)));
		managingBodyLabel.setText(ui.getString("fina2.bank.managingBody"));
		managingBodyLabel.setFont(ui.getFont());
		jPanel1.add(managingBodyLabel, new java.awt.GridBagConstraints());

		managingBodyText.setColumns(15);
		managingBodyText.setFont(ui.getFont());
		jPanel1.add(managingBodyText, UIManager.getGridBagConstraints(-1, -1, -1, -1, -1, -1, -1, -1, new java.awt.Insets(0, 5, 0, 0)));

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		helpButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				helpButtonActionPerformed(evt);
			}
		});

		jPanel3.add(helpButton);

		jPanel2.add(jPanel3);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel4.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel4.add(cancelButton);

		jPanel2.add(jPanel4);

		getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

		pack();
	}// GEN-END:initComponents

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_cancelButtonActionPerformed
		setVisible(false);
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-
		// FIRST
		// :
		// event_okButtonActionPerformed
		if (canAmend) {
			if (managingBodyText.getText().trim().equals("")) {
				ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.bank.pleaseEnterCity"));
				return;
			}
			try {
				InitialContext jndi = fina2.Main.getJndiContext();
				Object ref = jndi.lookup("fina2/bank/ManagingBody");
				ManagingBodyHome home = (ManagingBodyHome) PortableRemoteObject.narrow(ref, ManagingBodyHome.class);
				try {
					if (managingBody == null) {
						managingBody = home.create();
					}
				} catch (Exception e) {
					if (tableRow == null)
						managingBody = null;
					Main.generalErrorHandler(e);
					return;
				}

				UserTransaction trans = main.getUserTransaction(jndi);
				trans.begin();

				try {
					if (managingBody == null) {
						managingBody = home.create();
					}
					managingBody.setManagingBody(main.getLanguageHandle(), managingBodyText.getText());
					trans.commit();
				} catch (Exception e) {
					trans.rollback();
					if (managingBody == null) {
						managingBody.remove();
						managingBody = null;
					}
					Main.generalErrorHandler(e);
					return;
				}
				if (tableRow == null) {
					tableRow = new TableRowImpl(managingBody.getPrimaryKey(), 1);
					tableRow.setValue(0, managingBody.getManagingBody(main.getLanguageHandle()));
				} else {
					tableRow.setValue(0, managingBody.getManagingBody(main.getLanguageHandle()));
				}
			} catch (Exception e) {
				Main.generalErrorHandler(e);
			}
		}
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	private void helpButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_helpButtonActionPerformed
		// Add your handling code here:
	}// GEN-LAST:event_helpButtonActionPerformed

	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JLabel managingBodyLabel;
	private javax.swing.JTextField managingBodyText;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton okButton;
	private javax.swing.JButton cancelButton;
	// End of variables declaration//GEN-END:variables

}
