/*
 * ExcelSelectDialog.java
 *
 * Created on January 5, 2002, 4:32 PM
 */

package fina2.nbg;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JOptionPane;

import fina2.bank.BankSession;
import fina2.bank.BankSessionHome;
import fina2.ui.table.TableRowImpl;

/**
 *
 * @author  Administrator
 */
public class ExcelSelectDialog extends javax.swing.JDialog {

    private fina2.ui.UIManager ui = fina2.Main.main.ui;
    private fina2.Main main = fina2.Main.main;

    /** Creates new form ExcelSelectDialog */
    public ExcelSelectDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    public void show() {
        try {
            InitialContext jndi = fina2.Main.main.getJndiContext();
            Object ref = jndi.lookup("fina2/bank/BankSession");
            BankSessionHome home = (BankSessionHome) PortableRemoteObject
                    .narrow(ref, BankSessionHome.class);

            BankSession session = home.create();
            Collection rows = session.getBanksRows(main.getUserHandle(), main
                    .getLanguageHandle());

            for (Iterator iter = rows.iterator(); iter.hasNext();) {
                TableRowImpl row = (TableRowImpl) iter.next();
                row.setDefaultCol(1);
            }

            bankList.setModel(new javax.swing.DefaultComboBoxModel(new Vector(
                    rows)));
            //bankList.setSelectedIndex(0);

            Vector types = new Vector();
            types.add("Financial");
            types.add("Supervision");
            typeList.setModel(new javax.swing.DefaultComboBoxModel(types));
            //typeList.setSelectedIndex(0);

            pack();
            setLocationRelativeTo(getParent());
            super.show();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "error\n" + e.getMessage());
            System.exit(1);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        bankList = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        monthText = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        yearText = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        typeList = new javax.swing.JComboBox();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.add(jPanel3, java.awt.BorderLayout.WEST);

        jButton1.setFont(new java.awt.Font("Dialog", 0, 11));
        jButton1.setText("Ok");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel4.add(jButton1);

        jButton2.setFont(new java.awt.Font("Dialog", 0, 11));
        jButton2.setText("Cancel");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel4.add(jButton2);

        jPanel1.add(jPanel4, java.awt.BorderLayout.EAST);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;

        jPanel2.setBorder(new javax.swing.border.EmptyBorder(
                new java.awt.Insets(30, 70, 30, 70)));
        jLabel1.setText("Bank");
        jLabel1.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(jLabel1, gridBagConstraints1);

        bankList.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(bankList, gridBagConstraints1);

        jLabel2.setText("Month");
        jLabel2.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(jLabel2, gridBagConstraints1);

        monthText.setColumns(4);
        monthText.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(monthText, gridBagConstraints1);

        jLabel3.setText("Year");
        jLabel3.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(jLabel3, gridBagConstraints1);

        yearText.setColumns(7);
        yearText.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(yearText, gridBagConstraints1);

        jLabel4.setText("Type");
        jLabel4.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(jLabel4, gridBagConstraints1);

        typeList.setFont(new java.awt.Font("Dialog", 0, 11));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(typeList, gridBagConstraints1);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        TableRowImpl row = (TableRowImpl) bankList.getSelectedItem();
        String name = null;
        try {
            int y = Integer.valueOf(yearText.getText()).intValue();
            if (typeList.getSelectedIndex() == 0) {
                if (y >= 2002)
                    name = "F&S Files " + monthText.getText()
                            + yearText.getText() + "\\F";
                else
                    name = "R&S Files " + monthText.getText()
                            + yearText.getText() + "\\R";
            } else {
                if (y >= 2002)
                    name = "F&S Files " + monthText.getText()
                            + yearText.getText() + "\\III Dekada\\S3";
                else
                    name = "R&S Files " + monthText.getText()
                            + yearText.getText() + "\\S";
            }
        } catch (Exception e) {
        }
        name += row.getValue(0);
        name += monthText.getText();
        name += yearText.getText() + ".xls";
        System.out.println("\"" + main.getProperties().getProperty("excel.exe")
                + "\" \"" + main.getProperties().getProperty("xls.path") + "\\"
                + name + "\"");
        try {
            Runtime.getRuntime().exec(
                    "\"" + main.getProperties().getProperty("excel.exe")
                            + "\" \""
                            + main.getProperties().getProperty("xls.path")
                            + "\\" + name + "\"");
        } catch (Exception e) {
            System.out.println("Wrong Path !");
            //            ui.showMessageBox(this, ui.getString("fina2.nbg.fileNotFound"));
        }
        dispose();
    }//GEN-LAST:event_jButton1ActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JComboBox bankList;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField monthText;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField yearText;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JComboBox typeList;
    // End of variables declaration//GEN-END:variables

}
