/*
 * PeriodTypeDialog.java
 *
 * Created on October 31, 2001, 11:27 PM
 */

package fina2.period;

import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.ListSelectionModel;

import fina2.Main;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;

/**
 *
 * @author  vasop
 */
public class PeriodTypeSelectDialog extends javax.swing.JDialog {

    private fina2.ui.UIManager ui = fina2.Main.main.ui;
    private fina2.Main main = fina2.Main.main;

    private EJBTable table;
    private TableRow tableRow;

    /** Creates new form PeriodTypeDialog */
    public PeriodTypeSelectDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);

        ui.loadIcon("fina2.cancel", "cancel.gif");
        ui.loadIcon("fina2.ok", "ok.gif");

        table = new EJBTable();

        table
                .addSelectionListener(new javax.swing.event.ListSelectionListener() {
                    public void valueChanged(
                            javax.swing.event.ListSelectionEvent evt) {
                        if (table.getSelectedRow() == -1) {
                            okButton.setEnabled(false);
                        } else {
                            okButton.setEnabled(true);
                        }
                    }
                });

        table.addMouseListener(new java.awt.event.MouseListener() {
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
            }

            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
            }

            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
            }

            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                if (mouseEvent.getClickCount() > 1)
                    okButtonActionPerformed(null);
            }

            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
            }
        });

        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        initComponents();

        scrollPane.setViewportView(table);
        setLocationRelativeTo(parent);
    }

    public TableRow getTableRow() {
        return tableRow;
    }

    private void initTable() {
        try {
            InitialContext jndi = fina2.Main.getJndiContext();
            Object ref = jndi.lookup("fina2/period/PeriodSession");
            PeriodSessionHome home = (PeriodSessionHome) PortableRemoteObject
                    .narrow(ref, PeriodSessionHome.class);

            PeriodSession session = home.create();

            Vector colNames = new Vector();
            colNames.add(ui.getString("fina2.code"));
            colNames.add(ui.getString("fina2.description"));

            table.initTable(colNames, session.getPeriodTypeRows(main
                    .getUserHandle(), main.getLanguageHandle()));

        } catch (Exception e) {
            Main.generalErrorHandler(e);
        }
    }

    public void show() {
        if (isVisible())
            return;
        initTable();

        super.show();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setTitle(ui.getString("fina2.period.periodType"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        scrollPane.setPreferredSize(new java.awt.Dimension(350, 350));
        jPanel1.add(scrollPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        okButton.setIcon(ui.getIcon("fina2.ok"));
        okButton.setFont(ui.getFont());
        okButton.setText(ui.getString("fina2.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel2.add(okButton);

        cancelButton.setIcon(ui.getIcon("fina2.cancel"));
        cancelButton.setFont(ui.getFont());
        cancelButton.setText(ui.getString("fina2.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed

        tableRow = table.getSelectedTableRow();

        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

}
