/*
 * CreateFolderDialog.java
 *
 * Created on January 3, 2002, 10:08 PM
 */

package fina2.reportoo.repository;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import fina2.Main;

/**
 * 
 * @author David Shalamberidze
 */
public class AmendFolderDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private boolean ok;
	private int id;
	private String name;

	/** Creates new form CreateFolderDialog */
	public AmendFolderDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.help", "help.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		initComponents();
	}

	public void show(int id) {
		this.id = id;

		if (id != -1) {
			try {
				InitialContext jndi = fina2.Main.getJndiContext();

				Object ref = jndi.lookup("fina2/reportoo/repository/RepositorySession");
				RepositorySessionHome home = (RepositorySessionHome) PortableRemoteObject.narrow(ref, RepositorySessionHome.class);

				RepositorySession session = home.create();
				folderNameText.setText(session.getFolderName(id)
				// report.getDescription(main.getLanguageHandle())
						);
			} catch (Exception e) {
				Main.generalErrorHandler(e);
				return;
			}
		} else {
			folderNameText.setText("");
		}
		setLocationRelativeTo(getParent());
		super.show();
	}

	public boolean isOk() {
		return ok;
	}

	public String getName() {
		return name;
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel1 = new javax.swing.JPanel();
		jPanel3 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel4 = new javax.swing.JPanel();
		okButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();
		jPanel2 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		folderNameText = new javax.swing.JTextField();

		setTitle(ui.getString("fina2.report.folder"));
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel1.setLayout(new java.awt.BorderLayout());

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		jPanel3.add(helpButton);

		jPanel1.add(jPanel3, java.awt.BorderLayout.WEST);

		okButton.setIcon(ui.getIcon("fina2.ok"));
		okButton.setFont(ui.getFont());
		okButton.setText(ui.getString("fina2.ok"));
		okButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				okButtonActionPerformed(evt);
			}
		});

		jPanel4.add(okButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel4.add(cancelButton);

		jPanel1.add(jPanel4, java.awt.BorderLayout.EAST);

		getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

		jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(25, 70, 25, 70)));
		jLabel1.setText(ui.getString("fina2.report.folder"));
		jLabel1.setFont(ui.getFont());
		jPanel2.add(jLabel1);

		folderNameText.setColumns(15);
		folderNameText.setFont(ui.getFont());
		jPanel2.add(folderNameText);

		getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

		pack();
	}// GEN-END:initComponents

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelButtonActionPerformed
		ok = false;
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_okButtonActionPerformed
		if (folderNameText.getText().trim().length() == 0) {

			ui.showMessageBox(null, ui.getString("fina2.title"), ui.getString("fina2.invalidnameEmpty"));
			return;
		}
		name = folderNameText.getText();
		ok = true;
		dispose();
	}// GEN-LAST:event_okButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_closeDialog
		ok = false;
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton okButton;
	private javax.swing.JButton cancelButton;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JTextField folderNameText;
	// End of variables declaration//GEN-END:variables

}
