package fina2.returns;

import java.awt.GridBagConstraints;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.ListSelectionModel;

import fina2.Main;
import fina2.ui.UIManager;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;
import fina2.ui.table.TableRowImpl;

public class NotesReviewDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private ReturnPK returnPK;
	private EJBTable table;
	private String versionCode;

	/** Creates new form NotesReviewDialog */
	public NotesReviewDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		ui.loadIcon("fina2.close", "close.gif");

		table = new EJBTable();
		table.setAllowSort(false);
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		table
				.addSelectionListener(new javax.swing.event.ListSelectionListener() {
					public void valueChanged(
							javax.swing.event.ListSelectionEvent evt) {
						if (table.getSelectedRow() == -1) {
							notesText.setText(" ");

						} else {
							notesText.setText(table.getSelectedTableRow()
									.getValue(3));
						}
					}
				});

		initComponents();
		scrollPane.setViewportView(table);
		setLocationRelativeTo(parent);
	}

	private void initTable() {

		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/returns/ReturnSession");
			ReturnSessionHome returnHome = (ReturnSessionHome) PortableRemoteObject
					.narrow(ref, ReturnSessionHome.class);

			ReturnSession returnSession = returnHome.create();

			Vector colNames = new Vector();
			// colNames.add(ui.getString("fina2.bank.bank"));
			// colNames.add(ui.getString("fina2.from"));
			// colNames.add(ui.getString("fina2.to"));
			// colNames.add(ui.getString("fina2.returns.returnDefinition"));
			// colNames.add(ui.getString("fina2.code"));
			// colNames.add(ui.getString("fina2.version"));
			colNames.add(ui.getString("fina2.status"));
			colNames.add(ui.getString("fina2.date"));
			colNames.add(ui.getString("fina2.security.user"));

			Vector rows = (Vector) returnSession.getReturnStatuses(main
					.getLanguageHandle(), returnPK, versionCode);
			if (rows == null)
				return;
			for (java.util.Iterator iter = rows.iterator(); iter.hasNext();) {
				TableRowImpl row = (TableRowImpl) iter.next();

				switch (Integer.valueOf(row.getValue(0)).intValue()) {
				case ReturnConstants.STATUS_CREATED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_CREATED_STR));
					break;
				case ReturnConstants.STATUS_AMENDED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_AMENDED_STR));
					break;
				case ReturnConstants.STATUS_IMPORTED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_IMPORTED_STR));
					break;
				case ReturnConstants.STATUS_PROCESSED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_PROCESSED_STR));
					break;
				case ReturnConstants.STATUS_VALIDATED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_VALIDATED_STR));
					break;
				case ReturnConstants.STATUS_RESETED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_RESETED_STR));
					break;
				case ReturnConstants.STATUS_ACCEPTED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_ACCEPTED_STR));
					break;
				case ReturnConstants.STATUS_REJECTED:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_REJECTED_STR));
					break;
				case ReturnConstants.STATUS_ERRORS:
					row.setValue(0, ui
							.getString(ReturnConstants.STATUS_ERRORS_STR));
					break;
				default:
					row.setValue(0, " ");
				}

			}

			table.initTable(colNames, rows);

		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
	}

	public void show(ReturnPK pk, TableRow row) {
		returnPK = pk;
		versionCode = row.getValue(5);

		bankText.setText(row.getValue(0));
		fromText.setText(row.getValue(1));
		toText.setText(row.getValue(2));
		returnText.setText(row.getValue(3));
		returnCodeText.setText(row.getValue(4));

		initTable();
		super.show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		jPanel6 = new javax.swing.JPanel();
		jPanel4 = new javax.swing.JPanel();
		closeButton = new javax.swing.JButton();
		jPanel5 = new javax.swing.JPanel();
		helpButton = new javax.swing.JButton();
		jPanel1 = new javax.swing.JPanel();
		jSplitPane2 = new javax.swing.JSplitPane();
		jPanel2 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		returnText = new javax.swing.JTextField();
		jLabel2 = new javax.swing.JLabel();
		bankText = new javax.swing.JTextField();
		jLabel3 = new javax.swing.JLabel();
		fromText = new javax.swing.JTextField();
		jLabel4 = new javax.swing.JLabel();
		toText = new javax.swing.JTextField();
		returnCodeText = new javax.swing.JTextField();
		jSplitPane1 = new javax.swing.JSplitPane();
		jScrollPane6 = new javax.swing.JScrollPane();
		notesText = new javax.swing.JTextPane();
		scrollPane = new javax.swing.JScrollPane();

		setTitle(ui.getString("fina2.returns.statusHistory"));
		setFont(ui.getFont());
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jPanel6.setLayout(new java.awt.BorderLayout());

		closeButton.setIcon(ui.getIcon("fina2.close"));
		closeButton.setFont(ui.getFont());
		closeButton.setText(ui.getString("fina2.close"));
		closeButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				closeButtonActionPerformed(evt);
			}
		});

		jPanel4.add(closeButton);

		jPanel6.add(jPanel4, java.awt.BorderLayout.EAST);

		helpButton.setIcon(ui.getIcon("fina2.help"));
		helpButton.setFont(ui.getFont());
		helpButton.setText(ui.getString("fina2.help"));
		helpButton.setEnabled(false);
		jPanel5.add(helpButton);

		jPanel6.add(jPanel5, java.awt.BorderLayout.WEST);

		getContentPane().add(jPanel6, java.awt.BorderLayout.SOUTH);

		jPanel1.setLayout(new java.awt.GridLayout(1, 0));

		jSplitPane2.setDividerSize(2);
		jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
		jPanel2.setLayout(new java.awt.GridBagLayout());

		jLabel1.setText(ui.getString("fina2.returns.returnDefinition"));
		jLabel1.setFont(ui.getFont());
		jPanel2.add(jLabel1, UIManager.getGridBagConstraints(0, 0, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(5, 0, 5, 5)));

		returnText.setEditable(false);
		returnText.setColumns(28);
		returnText.setFont(ui.getFont());
		jPanel2.add(returnText, UIManager.getGridBagConstraints(1, 0, -1, -1,
				-1, -1, GridBagConstraints.WEST, -1, new java.awt.Insets(5, 0,
						5, 0)));

		jLabel2.setText(ui.getString("fina2.bank.bank"));
		jLabel2.setFont(ui.getFont());
		jPanel2.add(jLabel2, UIManager.getGridBagConstraints(0, 1, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(0, 0, 5, 5)));

		bankText.setEditable(false);
		bankText.setColumns(8);
		bankText.setFont(ui.getFont());
		jPanel2.add(bankText, UIManager.getGridBagConstraints(1, 1, -1, -1, -1,
				-1, GridBagConstraints.WEST, -1,
				new java.awt.Insets(0, 0, 5, 0)));

		jLabel3.setText(ui.getString("fina2.from"));
		jLabel3.setFont(ui.getFont());
		jPanel2.add(jLabel3, UIManager.getGridBagConstraints(0, 2, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(0, 0, 5, 5)));

		fromText.setEditable(false);
		fromText.setColumns(10);
		fromText.setFont(ui.getFont());
		jPanel2.add(fromText, UIManager.getGridBagConstraints(1, 2, -1, -1, -1,
				-1, GridBagConstraints.WEST, -1,
				new java.awt.Insets(0, 0, 5, 0)));

		jLabel4.setText(ui.getString("fina2.to"));
		jLabel4.setFont(ui.getFont());
		jPanel2.add(jLabel4, UIManager.getGridBagConstraints(0, 3, -1, -1, -1,
				-1, GridBagConstraints.EAST, -1,
				new java.awt.Insets(0, 0, 5, 5)));

		toText.setEditable(false);
		toText.setColumns(10);
		toText.setFont(ui.getFont());
		jPanel2.add(toText, UIManager.getGridBagConstraints(1, 3, -1, -1, -1,
				-1, GridBagConstraints.WEST, -1,
				new java.awt.Insets(0, 0, 5, 0)));

		returnCodeText.setEditable(false);
		returnCodeText.setColumns(8);
		returnCodeText.setFont(ui.getFont());
		jPanel2.add(returnCodeText, UIManager.getGridBagConstraints(2, 0, -1,
				-1, -1, -1, GridBagConstraints.EAST, -1, new java.awt.Insets(5,
						1, 5, 0)));

		jSplitPane2.setLeftComponent(jPanel2);

		jSplitPane1.setDividerSize(2);
		jScrollPane6.setPreferredSize(new java.awt.Dimension(300, 150));
		notesText.setEditable(false);
		notesText.setFont(ui.getFont());
		jScrollPane6.setViewportView(notesText);

		jSplitPane1.setRightComponent(jScrollPane6);

		scrollPane.setPreferredSize(new java.awt.Dimension(300, 150));
		jSplitPane1.setLeftComponent(scrollPane);

		jSplitPane2.setRightComponent(jSplitPane1);

		jPanel1.add(jSplitPane2);

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		pack();
	}// GEN-END:initComponents

	private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN
		// -
		// FIRST
		// :
		// event_closeButtonActionPerformed
		dispose();
	}// GEN-LAST:event_closeButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:
		// event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel6;
	private javax.swing.JPanel jPanel4;
	private javax.swing.JButton closeButton;
	private javax.swing.JPanel jPanel5;
	private javax.swing.JButton helpButton;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JSplitPane jSplitPane2;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JTextField returnText;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JTextField bankText;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JTextField fromText;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JTextField toText;
	private javax.swing.JTextField returnCodeText;
	private javax.swing.JSplitPane jSplitPane1;
	private javax.swing.JScrollPane jScrollPane6;
	private javax.swing.JTextPane notesText;
	private javax.swing.JScrollPane scrollPane;
	// End of variables declaration//GEN-END:variables

}
