/*
 * ScheduleAutoInsertConfirmDialog.java
 *
 * Created on November 20, 2001, 4:14 AM
 */

package fina2.returns;

import java.util.Collection;
import java.util.Date;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.ListSelectionModel;

import fina2.Main;
import fina2.ui.UIManager.IndeterminateLoading;
import fina2.ui.table.EJBTable;
import fina2.ui.table.TableRow;

//import fina2.period.PeriodPK;
//import fina2.bank.BankPK;
//import fina2.ReturnDefinitionPK;

/**
 * 
 * @author vasop
 */
public class ScheduleAutoInsertConfirmDialog extends javax.swing.JDialog {

	private fina2.ui.UIManager ui = fina2.Main.main.ui;
	private fina2.Main main = fina2.Main.main;

	private String type;
	private int frequencyType;
	private Date fromDate;
	private int startPeriodNumber;
	private int numberOfPeriods;
	private int daysInPeriods;
	private int daysBetweenPeriods;
	private int doa;

	private EJBTable table;
	private TableRow tableRow;

	private Collection bankPK;
	private Collection definitionPK;
	private Collection periodPK;

	private Collection tableRows;

	private Collection canceledRows = null;
	private int rowCount;
	private boolean ins;

	private IndeterminateLoading loading;

	/** Creates new form ScheduleAutoInsertConfirmDialog */
	public ScheduleAutoInsertConfirmDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);

		ui.loadIcon("fina2.cancel", "cancel.gif");
		ui.loadIcon("fina2.ok", "ok.gif");

		table = new EJBTable();
		table.setAllowSort(false);
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		table.addSelectionListener(new javax.swing.event.ListSelectionListener() {
			public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
				if (table.getSelectedRow() == -1) {
					insertButton.setEnabled(false);
				} else {
					insertButton.setEnabled(true);
				}
			}
		});

		initComponents();

		scrollPane.setViewportView(table);
		loading = ui.createIndeterminateLoading(main.getMainFrame());
	}

	public Collection getCanceledRows() {
		return canceledRows;
	}

	public int getRowCount() {
		return rowCount;
	}

	public boolean isInsert() {
		return ins;
	}

	private void initTable() {
		try {
			InitialContext jndi = fina2.Main.getJndiContext();
			Object ref = jndi.lookup("fina2/returns/ReturnSession");
			ReturnSessionHome home = (ReturnSessionHome) PortableRemoteObject
					.narrow(ref, ReturnSessionHome.class);

			ReturnSession session = home.create();

			Vector colNames = new Vector();
			colNames.add(ui.getString("fina2.bank.bank"));
			colNames.add(ui.getString("fina2.returns.return"));
			colNames.add(ui.getString("fina2.period.fromDate"));
			colNames.add(ui.getString("fina2.period.toDate"));

			table.initTable(colNames, session.getAutoSchedulesRows(
					main.getUserHandle(), main.getLanguageHandle(), bankPK,
					definitionPK, periodPK));

			rowCount = table.getRowCount();
		} catch (Exception e) {
			Main.generalErrorHandler(e);
		}
	}

	public void show(Collection bankPK, Collection definitionPK,
			Collection periodPK, int doa) {

		this.bankPK = bankPK;
		this.definitionPK = definitionPK;
		this.periodPK = periodPK;
		this.doa = doa;

		if (isVisible())
			return;

		initTable();

		setLocationRelativeTo(getParent());
		super.show();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {// GEN-BEGIN:initComponents
		scrollPane = new javax.swing.JScrollPane();
		jPanel1 = new javax.swing.JPanel();
		insertButton = new javax.swing.JButton();
		cancelButton = new javax.swing.JButton();

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		scrollPane.setBorder(null);
		scrollPane.setPreferredSize(new java.awt.Dimension(300, 300));
		getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);

		insertButton.setIcon(ui.getIcon("fina2.ok"));
		insertButton.setFont(ui.getFont());
		insertButton.setText(ui.getString("fina2.insert"));
		insertButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				insertButtonActionPerformed(evt);
			}
		});

		jPanel1.add(insertButton);

		cancelButton.setIcon(ui.getIcon("fina2.cancel"));
		cancelButton.setFont(ui.getFont());
		cancelButton.setText(ui.getString("fina2.cancel"));
		cancelButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelButtonActionPerformed(evt);
			}
		});

		jPanel1.add(cancelButton);

		getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

		pack();
	}// GEN-END:initComponents

	private void insertButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_insertButtonActionPerformed
		Thread t = new Thread() {
			public void run() {
				try {
					loading.start();
					InitialContext jndi = fina2.Main.getJndiContext();
					Object ref = jndi.lookup("fina2/returns/ReturnSession");
					ReturnSessionHome home = (ReturnSessionHome) PortableRemoteObject
							.narrow(ref, ReturnSessionHome.class);

					ReturnSession session = home.create();

					canceledRows = session.setAutoSchedulesRows(
							main.getLanguageHandle(), bankPK, definitionPK,
							periodPK, doa);
					ins = true;
					loading.stop();
				} catch (Exception e) {
					Main.generalErrorHandler(e);
				} finally {
					loading.stop();
				}
				dispose();
			}
		};
		t.start();
	}// GEN-LAST:event_insertButtonActionPerformed

	private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelButtonActionPerformed
		ins = false;
		dispose();
	}// GEN-LAST:event_cancelButtonActionPerformed

	/** Closes the dialog */
	private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_closeDialog
		setVisible(false);
		dispose();
	}// GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JScrollPane scrollPane;
	private javax.swing.JButton insertButton;
	private javax.swing.JButton cancelButton;
	private javax.swing.JPanel jPanel1;
	// End of variables declaration//GEN-END:variables

}
